// StripDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VobBlanker.h"
#include "StripDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;
extern CString Size_MBytes(__int64 i64size);
extern int GetNbytes(int nNumber,uchar* address);
extern int DurationInSecs(DWORD dwDuration);
extern CString lang_long(char* szLang);


/*
static struct
{
	char descr[3];
	char lang_long[20];
} LangTable[] = 
 */

/////////////////////////////////////////////////////////////////////////////
// CStripDlg dialog


CStripDlg::CStripDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStripDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStripDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CStripDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStripDlg)
	DDX_Control(pDX, IDC_LISTSTTRIP, m_CList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStripDlg, CDialog)
	//{{AFX_MSG_MAP(CStripDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStripDlg message handlers

BOOL CStripDlg::OnInitDialog()
{
	int nAudio,nA,nCode,nId,nBitrate;
	int i,j;
	int nAA;
	int iAudDelay;
	CString csAux,csAux2;


	CDialog::OnInitDialog();

	//CLISTCTRL HEADERS
	i=0;
	if (m_mode==STRIP)
		m_CList.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_CHECKBOXES );
	else
		m_CList.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );

	m_CList.SetItemCount(10);

	if (m_mode==STRIP)
	{
		m_CList.InsertColumn( i, "Action");
		m_CList.SetColumnWidth( i, 80);
		i++;
	}
	m_CList.InsertColumn( i, "#");
	m_CList.SetColumnWidth( i, 20); 
	i++;
	if (m_mode==STRIP || m_mode==AUDINFO)
		m_CList.InsertColumn( i, "track id");
	else
		m_CList.InsertColumn( i, "1st track id");

	m_CList.SetColumnWidth( i, 50); 
	i++;
	m_CList.InsertColumn( i, "Code");
	m_CList.SetColumnWidth( i, 60); 
	i++;
	m_CList.InsertColumn( i, "# Channels");
	m_CList.SetColumnWidth( i, 50); 
	i++;
	m_CList.InsertColumn( i, "Type");
	m_CList.SetColumnWidth( i, 125); 
	i++;
	m_CList.InsertColumn( i, "Language");
	m_CList.SetColumnWidth( i, 80); 
	i++;
	m_CList.InsertColumn( i, "kbps");
	m_CList.SetColumnWidth( i, 40); 
	i++;
	m_CList.InsertColumn( i, "Estimated size");
	m_CList.SetColumnWidth( i, 80); 
	i++;
	if (m_mode==AUDINFO)
	{
		m_CList.InsertColumn( i, "Delay (msec)");
		m_CList.SetColumnWidth( i, 80); 
		i++;
	}

	for (nA=0; nA<8; nA++)
	{
		m_i64Asize[nA]=0;
	}

	nAudio=theApp.m_nAudio[m_nVTS];


	for (nA=0; nA<nAudio; nA++)
	{
		nCode=theApp.m_pIFO[m_nVTS][0x204+8*nA] >> 5;

		if (m_mode==STRIP)
		{
			m_CList.InsertItem(nA, "Keep track");
			if (theApp.m_bIdTAudioStrip[m_nVTS][nA][m_nT])
				m_CList.SetCheck(nA, FALSE);
			else
				m_CList.SetCheck(nA, TRUE);

			csAux.Format(_T("%d"),nA+1);
			m_CList.SetItemText(nA,1, csAux);
			j=2;
		}
		else
		{
			csAux.Format(_T("%d"),nA+1);
			m_CList.InsertItem(nA, csAux);
			j=1;
		}
		// track id
		if (nCode==0) csAux="ac3";
		if (nCode==1) csAux="???";
		if (nCode==2) csAux="Mpeg1";
		if (nCode==3) csAux="Mpeg2";
		if (nCode==4) csAux="LPCM";
		if (nCode==5) csAux="???";
		if (nCode==6) csAux="DTS";
		if (nCode==7) csAux="???";
/*		if (nCode==0) { nId+=0x80; csAux="ac3";}
		if (nCode==1) { nId+=0x80; csAux="???";}
		if (nCode==2) { nId+=0xC0; csAux="Mpeg1";}
		if (nCode==3) { nId+=0xC8; csAux="Mpeg2";}
		if (nCode==4) { nId+=0xA0; csAux="LPCM";}
		if (nCode==5) { nId+=0x80; csAux="???";}
		if (nCode==6) { nId+=0x88; csAux="DTS";}
		if (nCode==7) { nId+=0x80; csAux="???";}
*/
		if (m_mode==STRIP || m_mode==AUDINFO)
			nId=theApp.m_iIdTAudio[m_nVTS][nA][m_nT];
		else
			nId=theApp.m_iIdAudio[m_nVTS][nA];

		csAux2.Format(_T("%02X"),nId);
		if (nId==-1)
			csAux2.Format(_T("None"));


		m_CList.SetItemText(nA,j, csAux2);
		j++;

		// code
		m_CList.SetItemText(nA,j, csAux);
		j++;

		// Channels
		csAux.Format(_T("%d"),(theApp.m_pIFO[m_nVTS][0x204+8*nA+1] & 0x7) +1 );
		m_CList.SetItemText(nA,j, csAux);
		j++;

		// Type
		if(	theApp.m_pIFO[m_nVTS][0x204+8*nA+5]==0 ) csAux="Unspecified";
		if(	theApp.m_pIFO[m_nVTS][0x204+8*nA+5]==1 ) csAux="Normal";
		if(	theApp.m_pIFO[m_nVTS][0x204+8*nA+5]==2 ) csAux="For visually impaired";
		if(	theApp.m_pIFO[m_nVTS][0x204+8*nA+5]==3 ) csAux="Director's comments";
		if(	theApp.m_pIFO[m_nVTS][0x204+8*nA+5]==4 ) csAux="Alt. director's comments";
		m_CList.SetItemText(nA,j, csAux);
		j++;

		// Language
		if ( ( (theApp.m_pIFO[m_nVTS][0x204+8*nA] >> 2) & 0x1 ) == 0)
			csAux="Unspecified";
		else
			csAux=lang_long((char *) &theApp.m_pIFO[m_nVTS][0x204+8*nA+2]);
	
		m_CList.SetItemText(nA,j, csAux);
		j++;

		// kpbs

		if (m_mode==STRIP || m_mode==AUDINFO)
		{
			for (nAA=0,nBitrate=0; nAA<nAudio && nBitrate ==0; nAA++)
				if (theApp.m_iIdTAudio[m_nVTS][nA][m_nT] == theApp.m_iIdAudio[m_nVTS][nAA])
					nBitrate=theApp.m_iBRAudio[m_nVTS][nAA];
		}
		else
			nBitrate=theApp.m_iBRAudio[m_nVTS][nA];
		csAux="???";
		if (nId==-1) csAux="---";
		if (nBitrate!=0)
			csAux.Format(_T("%d"),nBitrate);
		m_CList.SetItemText(nA, j , csAux);
		j++;

		// Size

		if (m_mode==STRIP || m_mode==AUDINFO )
		{
			if (theApp.ST_GetAudioStatus(m_nVTS, m_nT, nA) & 0x80 )
				m_i64Asize[nA]=DurationInSecs(theApp.m_dwDurationOwn[m_nVTS][m_nT])*nBitrate;
		}
		else
			for (i=0, m_i64Asize[nA]=0; i<theApp.m_nPGCs[m_nVTS];i++)
			{
				if (theApp.ST_GetAudioStatus(m_nVTS, i, nA) & 0x80 )
					m_i64Asize[nA]+=DurationInSecs(theApp.m_dwDurationOwn[m_nVTS][i])*nBitrate;
			}
		m_i64Asize[nA]=m_i64Asize[nA]*1000/8;
		if (nBitrate==0 && nId!=-1) csAux="Unknown";
		else
			csAux=Size_MBytes(m_i64Asize[nA]);
		m_CList.SetItemText(nA,j, csAux);
		j++;

		// Delay
		if (m_mode==AUDINFO)
		{
			iAudDelay=theApp.ST_GetAudioDelay(m_nVTS, m_nT, nA);
			if (iAudDelay==0x7fffffff )
				csAux="???";
			else
				csAux.Format(_T("%d"),iAudDelay);
			m_CList.SetItemText(nA,j, csAux);
			j++;
		}
	}

	UpdateData(FALSE);

	CWnd * pWnd;
	int OFFX,OFFY;
	CRect myRect;
	CRect myRectApp;

	if (m_mode != STRIP )
	{
		pWnd=GetDlgItem(IDCANCEL);
		pWnd->SetWindowText("Close");
		pWnd=GetDlgItem(IDOK);
		pWnd->ShowWindow(SW_HIDE);
		pWnd=GetDlgItem(IDC_STATIC1);
		pWnd->ShowWindow(SW_HIDE);
		SetWindowText("Audio Attributes");
	}
	if (m_mode == ATTRIB )
	{
//		GetClientRect(&m_RectApp);
		GetWindowRect(&myRect);
//		OFFX=(myRect.Width()-m_RectApp.Width())/2;    // OFFX=Border
//		OFFY=myRect.Height()-m_RectApp.Height()-OFFX; // OFFY=Top border+Caption+Menu. 

		MoveWindow(myRect.left,myRect.top,myRect.Width() - 80, myRect.Height());
		pWnd=GetDlgItem(IDC_LISTSTTRIP);
		pWnd->GetClientRect(&myRectApp);
		pWnd->GetWindowRect(&myRect);
		OFFX=(myRect.Width()-myRectApp.Width())/2;    // OFFX=Border
		OFFY=myRect.Height()-myRectApp.Height()-OFFX; // OFFY=Top border+Caption+Menu. 

		pWnd->MoveWindow(myRectApp.left+OFFX+15,myRectApp.top+OFFY,myRectApp.Width() - 75, myRectApp.Height());
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CStripDlg::OnOK() 
{
	// TODO: Add extra validation here
	int nAudio, nA;

	nAudio=GetNbytes(2,&theApp.m_pIFO[m_nVTS][0x202]);
	theApp.m_i64Rsize[m_nVTS][m_nT]=theApp.m_i64Tisize[m_nVTS][m_nT];


	for (nA=0; nA<nAudio; nA++)
	{
		if (m_CList.GetCheck(nA) != TRUE)
		{
			theApp.m_bIdTAudioStrip[m_nVTS][nA][m_nT]=true;
			theApp.m_i64Rsize[m_nVTS][m_nT]-=m_i64Asize[nA];
		}
		else
		{
			theApp.m_bIdTAudioStrip[m_nVTS][nA][m_nT]=false;
		}
	}

	CDialog::OnOK();
}

void CStripDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if (m_mode==STRIP)	theApp.m_i64Rsize[m_nVTS][m_nT]=0;
	CDialog::OnCancel();
}
